        .Model Tiny
        .Code
        .286
        org 100h
Begin:
        Call ReadBoot
        mov ah,4
        mov bp,offset Hello
        int 0F4h                       ;뢥 ப
        xor ah,ah
        int 16h                        ;   
        jc ErrorFormat
        mov ah,4
        mov bp,offset String1
        int 0F4h                       ;뢥 ப

        mov dl,00h                     ;᪮ a: - 00
        mov bx,offset DiskParam        ; ⠡ ࠬ஢
Begin1:
        mov byte ptr [NFormat],00h
        mov ch,byte ptr DiskParam      ;
        mov dh,byte ptr DiskParam+1    ;
Begin11:
        mov ah,05h                     ;㭪
        mov al,18                      ;᫮ ᥪ஢
        int 13h                        ;ଠ஢ ஦
        jnc Begin12                    ;᫨  訡
        inc byte ptr [NFormat]
        cmp byte ptr [NFormat],10      ;10 ⮪ ⥭
        jne Begin11
        jmp ErrorFormat
Begin12:
        Call NextP                     ;뢥 稪  ࠭
        Call NextG                     ; 
        cmp byte ptr DiskParam+1,00
        jne Begin2
        cmp ch,80
        je EndBegin
        Call NextC                     ;騩 樫
Begin2:
        jmp Begin1
EndBegin:
        Call WriteBoot
        mov di,offset Sector
        mov dx,1
EndBegin1:
        int 0F2h
        inc dx
        cmp dx,34
        jne EndBegin1                  ; FAT  ROOT

        mov byte ptr [Sector  ],0F0h   ;Ŀ
        mov byte ptr [Sector+1],0FFh   ;   FAT1
        mov byte ptr [Sector+2],0FFh   ;  FAT2 㦥-
        mov dx,1                       ;  ଠ-
        int 0F2h                       ; .
        mov dx,10                      ; 
        int 0F2h                       ;

        mov ah,3
        int 0F5h                       ; FAT  ROOT

        mov ah,4
        mov bp,offset EndFormatStr
        int 0F4h                       ;뢥 ப
        ret
;Ŀ
;⠥ ୥ ᥪ.                                                    
;
ReadBoot proc
        mov di,offset BootSector
        mov dx,0
        int 0F1h                        ; BootSector
        ret
ReadBoot endp

;Ŀ
;뢠 ୥ ᥪ.                                                
;
WriteBoot proc
        mov di,offset BootSector
        mov dx,0
        int 0F2h                        ; BootSector
        ret
WriteBoot endp

;Ŀ
;⠭ ᫥ .                                           
;
NextG proc
        pusha
        mov di,offset DiskParam+1
        mov cx,18
        mov ah,00h
        cmp byte ptr [DiskParam+1],00h
        jne NextG1
        mov ah,01h
NextG1:
        mov byte ptr [di],ah
        add di,4
        loop NextG1
        popa
        ret
NextG endp

;Ŀ
;⠭ ᫥騩 樫.                                           
;
NextC proc
        pusha
        mov di,offset DiskParam
        mov cx,18
        mov ah,byte ptr [DiskParam]
        inc ah
NextC1:
        mov byte ptr [di],ah
        add di,4
        loop NextC1
        popa
        ret
NextC endp

;Ŀ
;C稪.                                                                   
;
NextP proc
        pusha
        mov ah,03h
        xor bh,bh
        int 10h                        ;  
        mov dl,0                       ;⮫ 0
        mov ah,02h
        xor bh,bh
        int 10h                        ; 
        popa
        pusha
        mov al,ch
        aam
        add ax,3030h
        xchg ah,al
        push ax
        mov ah,0Ah
        xor bh,bh
        mov cx,1
        int 10h                        ;뢥 ᨬ  ⥪  
        mov ah,03h
        int 10h                        ;  
        inc dl                         ; ⮫
        mov ah,02h
        xor bh,bh
        int 10h                        ; 
        pop ax
        xchg al,ah
        mov ah,0Ah
        xor bh,bh
        mov cx,1
        int 10h                        ;뢥 ᨬ  ⥪  
        popa
        ret
NextP endp

;Ŀ
;᫨ 訡.                                                               
;
ErrorFormat:
        mov ah,4
        mov bp,offset ErrorStr
        int 0F4h
        ret

Hello        db 0Ah,0Dh,'⠢  ᪥  ᪮ a:    ','$'
String1      db 0Ah,0Dh,'00 樫஢ ଠ஢','$'
EndFormatStr db 0Ah,0Dh,'ଠ஢ 襭','$'
ErrorStr     db 0Ah,0Dh,'訡 ଠ஢ ᪥','$'
NFormat      db 00h                    ;⢮ ⮪ ଠ஢
;ࠬ          ᥪ (2 - 512 )
DiskParam    db 0,      0,      1,     2
             db 0,      0,      2,     2
             db 0,      0,      3,     2
             db 0,      0,      4,     2
             db 0,      0,      5,     2
             db 0,      0,      6,     2
             db 0,      0,      7,     2
             db 0,      0,      8,     2
             db 0,      0,      9,     2
             db 0,      0,     10,     2
             db 0,      0,     11,     2
             db 0,      0,     12,     2
             db 0,      0,     13,     2
             db 0,      0,     14,     2
             db 0,      0,     15,     2
             db 0,      0,     16,     2
             db 0,      0,     17,     2
             db 0,      0,     18,     2
Sector       db 512 dup(00h)
BootSector:
end Begin